/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.TarifaMinimaDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Plaza;
import com.rjconsultores.ventaboletos.entidad.TarifaMinima;
import com.rjconsultores.ventaboletos.entidad.TarifaMinimaCategoria;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.service.TarifaMinimaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author rodrigo
 */
@Service("tarifaMinimaService")
public class TarifaMinimaServiceImpl implements TarifaMinimaService {

    @Autowired
    private TarifaMinimaDAO tarifaMinimaDAO;

    public List<TarifaMinima> obtenerTodos() {
        return tarifaMinimaDAO.obtenerTodos();
    }

    public TarifaMinima obtenerID(Integer id) {
        return tarifaMinimaDAO.obtenerID(id);
    }

    @Transactional
    public TarifaMinima suscribir(TarifaMinima entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tarifaMinimaDAO.suscribir(entidad);
    }

    @Transactional
    public TarifaMinima actualizacion(TarifaMinima entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tarifaMinimaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(TarifaMinima entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        tarifaMinimaDAO.actualizacion(entidad);
    }

    public List<TarifaMinima> buscarPorPlaza(Plaza plaza) {
        return tarifaMinimaDAO.buscarPorPlaza(plaza);
    }

    public List<TarifaMinima> pesquisar(Marca marca, Parada origem, Parada destino,
            ClaseServicio claseServicio, Moneda moneda,VigenciaTarifa vigenciaTarifa) {
        return tarifaMinimaDAO.pesquisar(marca, origem, destino, claseServicio, moneda,vigenciaTarifa);
    }

    public List<TarifaMinima> pesquisar(BigDecimal valor, Moneda moneda,
            Plaza plaza, Marca marca, Parada origem, Parada destino,
            ClaseServicio claseServicio) {
        return tarifaMinimaDAO.pesquisar(valor, moneda, plaza, marca, origem,
                destino, claseServicio);
    }
    
    public List<TarifaMinima> pesquisar( TarifaMinima tarifaMinima) {
        return tarifaMinimaDAO.pesquisar( tarifaMinima);
    }

    public List<TarifaMinima> pesquisarEspecifico(Marca marca, Parada origem,
            Parada destino, ClaseServicio claseServicio, Moneda moneda, VigenciaTarifa vigenciaTarifa) {
        return tarifaMinimaDAO.pesquisar(marca, origem, destino, claseServicio, moneda,vigenciaTarifa);
    }

    public List<TarifaMinima> pesquisarOrigemDestinoTodos(Marca marca, Parada origem,Parada destino,ClaseServicio claseServicio, Moneda moneda,VigenciaTarifa vigenciaTarifa) {
        return tarifaMinimaDAO.pesquisarOrigemDestinoTodos(marca, origem, destino, claseServicio, moneda,vigenciaTarifa);
    }

    public List<TarifaMinima> buscarPorMarca(Marca marca, Moneda moneda) {
        return tarifaMinimaDAO.buscarPorMarcaMoneda(marca, moneda);
    }

    public List<TarifaMinima> buscarPorClaseServico(ClaseServicio claseServicio,
            Moneda moneda) {
        return tarifaMinimaDAO.buscarPorClaseServicioMoneda(claseServicio, moneda);
    }

    public List<TarifaMinima> buscarPorPlazaMoneda(Plaza plaza, Moneda moneda) {
        return tarifaMinimaDAO.buscarPorPlazaMoneda(plaza, moneda);
    }

	@Override
	public TarifaMinimaCategoria adicionarTarifaMinimaCategoria(TarifaMinimaCategoria tarifaMinimaCategoria) {
		tarifaMinimaCategoria.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		tarifaMinimaCategoria.setFecmodif(new Date());
		tarifaMinimaCategoria.setActivo(Boolean.TRUE);
		return tarifaMinimaDAO.adicionarTarifaMinimaCategoria(tarifaMinimaCategoria);
	}

	@Override
	public void removerTarifaMinimaCategoria(TarifaMinimaCategoria tarifaMinimaCategoria) {
		tarifaMinimaCategoria.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		tarifaMinimaCategoria.setFecmodif(new Date());
		tarifaMinimaCategoria.setActivo(Boolean.FALSE);
		tarifaMinimaDAO.removerTarifaMinimaCategoria(tarifaMinimaCategoria);
	}
}
